<template>
    <div>
        <h6 id="destaques" class="q-ma-none q-mx-sm q-mt-md text-bold text-uppercase">Destaques</h6>
        <div class="row q-gutter-md" v-if="isLoading">
            <div class="col-12 col-md">
                <q-skeleton width="100%" height="100px" />
            </div>
            <div class="col-12 col-md">
                <q-skeleton width="100%" height="100px" />
            </div>
        </div>
        <div v-else class="row">
            <div v-for="(destaque, index) in destaques" :key="index" class="col-12 col-md-6 q-pa-none q-px-xs q-pb-sm">
                <q-item class="bg-grey-3 shadow-1" :style="{ borderRadius: $q.platform.is.desktop ? '5px' : '' }">
                    <q-item-section avatar :style="{ width: '100% !important' }">
                        <div v-if="$q.platform.is.desktop" class="row full-width">
                            <div class="col-4">
                                <q-img
                                    @error="loadDefaultProductImage(index)"
                                    :style="{ borderRadius: '5px' }" width="180px" height="120px" no-native-menu
                                    :src="destaque.src_image"
                                >
                                    <div class="absolute-bottom text-subtitle1 text-center">
                                        <h6 class="q-ma-none text-bold">{{ parseFloat(destaque.preco_unidade_venda).toLocaleString('pt-BR', { style: 'currency', currency: 'BRL' }) }}</h6>
                                    </div>
                                </q-img>
                            </div>
                            <div class="col-8 q-px-sm">
                                <h6 class="q-ma-none text-bold">{{ destaque.descricao_geral }}</h6>
                                <p class="q-ma-none text-grey-7 ellipsis-3-lines">
                                    {{ destaque.observacoes }}
                                </p>
                            </div>
                        </div>

                        <div v-else class="row full-width">
                            <div class="col-3 relative-position">
                                <q-img
                                    @error="loadDefaultProductImage(index)"
                                    :style="{ borderRadius: '5px' }" width="70px" height="70px" no-native-menu
                                    :src="destaque.src_image"
                                />
                                <div class="absolute bg-white text-center" :style="{ bottom: '0px', width: '70px', borderRadius: '0px 0px 5px 5px' }">
                                    <p class="q-ma-none text-bold">{{ parseFloat(destaque.preco_unidade_venda).toLocaleString('pt-BR', { style: 'currency', currency: 'BRL' }) }}</p>
                                </div>
                            </div>
                            <div class="col-9 q-pl-md">
                                <p class="q-ma-none text-bold ellipsis">{{ destaque.descricao_geral }}</p>
                                <p class="q-ma-none text-grey-7 ellipsis-3-lines" :style="{ fontSize: '10px' }">
                                    {{ destaque.observacoes }}
                                </p>
                            </div>
                        </div>
                    </q-item-section>
                </q-item>
            </div>
        </div>
    </div>
</template>

<script setup>
import { useSearchStore } from "../stories/searchStore";
import { useGroupButtons } from "../stories/groupButtons";
import { useStoreInfo } from "../stories/storeInfo";
import {DetailsProduct} from "./";
import { useQuasar } from "quasar";
import { onMounted, ref, watch } from 'vue';
import api from '../axios/api'

const emit = defineEmits(['noData', 'hasData']);

const $q = useQuasar();
const storeInfo = useStoreInfo();
const groupButtons = useGroupButtons();
const searchStore = useSearchStore();
const destaques = ref([]);
const originData = ref([]);
const isLoading = ref(false);
async function loadHighLightProducts () {
    isLoading.value = true;
    const result = await api.get('/api/products/highlights', {
        transformResponse: api.defaults.transformResponse.concat(function (data, headers) {
            Object.keys(data.data).forEach(function (index) {
                data.data[index].src_image = `https://api.flex.fsbr.com.br/uploads/${String(data.data[index].codigo_filial).padStart(5, '0')}_${String(data.data[index].codigo_produtos).padStart(10, '0')}.jpg`
            });
            return data;
        })
    }).catch(error => error).finally(() => isLoading.value = false)
    if (result.error || result.data.data.length === 0) emit('noData')
    destaques.value = result.data.data
    originData.value = result.data.data

    groupButtons.updateGroupButtons(['destaques']);
}
function loadDefaultProductImage (index) {
    destaques.value[index].src_image = `${import.meta.env.VITE_APP_URL}/img/default.png`
}
function showDetailsProduct (props) {
    $q.dialog({
        component: DetailsProduct,
        componentProps: { objectData:  props }
    }).onOk(() => {
        alert("FECHOU")
    })
}

watch(() => storeInfo.storeInfo, (newValue) => {
    if(newValue) loadHighLightProducts();
}, { deep: true, immediate: true })

watch(() => searchStore.searchTerm, (newValue) => {
    destaques.value = originData.value.filter(item => item.descricao_geral.toLowerCase().includes(newValue))
    emit('noData', destaques.value.length === 0)
})
</script>
